import org.junit.jupiter.api.Test;
import static org.junit.jupiter.api.Assertions.*;

/**
 * The HiddenTests class for the Lab in CSC207, Fall 2022.
 * These tests are intended for marking.  In our class, we gave 25% of the marks for passing student tests.
 * Another 75% of the marks were awarded for passing the tests below.
 */
class HiddenTests {

    @Test
    void currCarbonContentHiddenTest() {
        Forest f1 = new Forest(100);
        Forest f2 = new Forest(1000);
        assertEquals(1978.5, f1.currCarbonContent(), 1, "Failed calculating carbon content of forest of small trees.");
        assertEquals(19785.8, f2.currCarbonContent(), 1, "Failed calculating carbon content of forest of small trees.");
    }

    @Test
    void growHiddenTest() {
        WhiteAsh t = new WhiteAsh(30);
        t.grow(2.0);
        assertEquals(30.6,t.getDiameter(), "Failed growing a tree of diameter 30.");
        t.fellTree();
        t.grow(2.0);
        assertEquals(0, t.getDiameter(), "Failed growing a tree of diameter 30.");
    }

    @Test
    void carbonContentHiddenTest() {
        WhiteAsh t1 = new WhiteAsh(35);
        WhiteAsh t2 = new WhiteAsh(50);
        assertEquals(202.0,Math.round(t1.carbonContent()), 1, "Failed calculating carbon in a tree of diameter 30.");
        assertEquals(438.0, Math.round(t2.carbonContent()), 1, "Failed calculating carbon in a tree of diameter 50.");
    }

    @Test
    void fellTreeHiddenTest() {
        WhiteAsh t = new WhiteAsh(30);
        t.fellTree();
        assertEquals(0, t.getDiameter(), "Failed felling a tree of diameter 30.");
        assertFalse(t.getLiving(), "Failed felling a tree of diameter 30 (tree is still alive).");
    }

    @Test
    void equalHiddenTest() {
        WhiteAsh t1 = new WhiteAsh(30);
        WhiteAsh t2 = new WhiteAsh(30);
        assertEquals(t1, t2, "Failed  asserting equality of living trees.");
        t1.fellTree();
        t2.fellTree();
        assertEquals(t1, t2, "Failed asserting equality of dead trees.");
    }

    @Test
    void notEqualHiddenTest() {
        WhiteAsh t1 = new WhiteAsh(30);
        WhiteAsh t2 = new WhiteAsh(30);
        WhiteAsh t3 = new WhiteAsh(40);
        t2.fellTree();
        assertNotEquals(t1, t2, "Failed  asserting equality of living and dead trees.");
        assertNotEquals(t1, t3, "Failed  asserting equality of big and small trees.");
    }

    @Test
    void equalsDifferentObjHiddenTest() {
        WhiteAsh t = new WhiteAsh(30);
        assertNotEquals(t, new Object(), "Failed  asserting equality of different objects.");
    }

    @Test
    void hashCodeEqualHiddenTest() {
        WhiteAsh t1 = new WhiteAsh(30);
        WhiteAsh t2 = new WhiteAsh(30);
        assertEquals(t1.hashCode(), t2.hashCode(), "Failed  asserting equality of living tree hashCodes.");
        t1.fellTree();
        t2.fellTree();
        assertEquals(t1.hashCode(), t2.hashCode(), "Failed  asserting equality of dead tree hashCodes.");
    }

    @Test
    void hashCodeUnequalHiddenTest() {
        WhiteAsh t1 = new WhiteAsh(30);
        WhiteAsh t2 = new WhiteAsh(40);
        assertNotEquals(t1.hashCode(), t2.hashCode(), "Failed  asserting inequality of tree hashCodes.");
    }

    @Test
    void compareToHiddenTest() {
        WhiteAsh t1 = new WhiteAsh(30);
        WhiteAsh t2 = new WhiteAsh(30);
        WhiteAsh t3 = new WhiteAsh(40);
        assertEquals(0, t1.compareTo(t2), "Failed comparing equal trees.");
        assertEquals(-1, t1.compareTo(t3), "Failed comparing unequal trees (one is big, one small).");
        t3.fellTree();
        assertEquals(1, t1.compareTo(t3), "Failed comparing unequal trees (one is dead).");
        assertEquals(-1, t3.compareTo(t1), "Failed comparing unequal trees (one is dead)");
        t1.fellTree();
        assertEquals(0, t1.compareTo(t3), "Failed comparing equal trees (both are dead)");
    }


}