# Project Title

LAB 2 FILES

## Description

What's in this folder:

**lab2.pdf**: the specification for the second urban forestry lab

**lab-setup-tutorial.pdf**: a tutorial that explains how to set up teh lab and configure JavaFX. A video tutorial of setup is here: https://web.microsoftstream.com/video/b5e1ed89-0c5a-4da1-927c-4b71b067ca7d. 

**results.csv**: output (grades) derived from use of the automarking scripts in the "shared_files" directory.

**starter_files**: folder containing Java files to release to students, including sanity tests (written with JUnit 5)

**example_submissions**: folder containing three example submissions ('bad', 'good', and 'ok').  Can be used to calibrate marking criteria. A script for marking that has been tested on a Mac can be found in the "shared_files" directory.  The script will output a version of the "report.txt" file that is found inside each student submission folder.

**supporting_files**: folder containing HiddenTests (JUnit5 tests to use for marking code that does not depend on the GUI), TreeViewerTest.java and TreeViewerTestBase.java (TextFX tests to use for marking), StudentTests (JUnit5 tests to be released to students) and a template for a summary of all testing results that can be delivered to students. A script to generate marking summaries that has been tested on a Mac can be found in the "shared_files" directory.

**screenreader_files**: folder containing an example solution containing screenreader hooks (for Narrator or VoiceOver).  These make use of the javax.accessibility package. A video demo of the lab version that includes javax.accessibility screen reader hooks is here: https://web.microsoftstream.com/video/9713e085-1112-478d-a062-9ba214b43726


### Dependencies

* Java 18
* JavaFX 18
* JUnit 5
* TestFX version 4 (for marking the GUI)
* Apache Maven 3.6.3 (for marking of the GUI)

### Suggested Marking Criteria

* Award 25% for passing student tests (in StudentTests.java)
* Award 75% for passing hidden tests (in HiddenTests.java, TreeViewerTest.java and TreeViewerTestBase.java; includes both JUnit5 and TestFX tests)

## Issues/Insights

Running GUI tests invoves complicated setup and configuration that depends in part on one's windowing system.
It is not expected that students in CS2 will be able to create any tests of this kind.
Students are therefore only given Junit5 tests as sanity tests.  

Marking, however, can in theory include GUI tests. A few GUI tests are been included in the **supporting_files** folder.

Also of note: There is a version of this lab that interfaces with a screenreader in the **screenreader_fiiles**. JavaFX ComboBoxes apparently don't interface with the screenreader hooks but ChoiceBox do!  Hence the use of this widget in the screenreading example.

## For More Information, Contact

Sonya Allin
University of Toronto Mississauga
s.allin@utoronto.ca

