import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import treetools.MunicipalTree;
import treetools.TreeInfo;
import treetools.TreeReader;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import static org.junit.jupiter.api.Assertions.assertEquals;

/**
 * The StudentTests class for the Lab in CSC207, Fall 2022.
 * These tests are sanity tests and are therefore not comprehensive!
 * Make sure to write your own tests in order to verify that your code works as expected.
 */
public class StudentTests {

    List<MunicipalTree> trees;

    @BeforeEach
    void getTrees(){
        try {
            String filename = "assets/treelist-utm.csv"; //change this accordingly
            this.trees = TreeReader.readTreesFromFile(filename);
        } catch (IOException ioe) {
            throw new RuntimeException(ioe);
        }
    }

    @Test
    void countTreeTest() {
        int count = TreeInfo.getTreeCount("BALSAM FIR", this.trees);
        assertEquals(37,count);
    }

    //List<MunicipalTree> trees;
    @Test
    void getTreeTypeTest() {
        ArrayList<MunicipalTree> trees;
        try {
            String filename = "assets/treelist-utm.csv"; //change this accordingly
            trees = (ArrayList<MunicipalTree>) TreeReader.readTreesFromFile(filename);
        } catch (IOException ioe) {
            throw new RuntimeException(ioe);
        }
        final Set<String> types = TreeInfo.getTreeTypes(trees);
        assertEquals(184,types.size());
    }

}
