import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import treetools.MunicipalTree;
import treetools.TreeInfo;
import treetools.TreeReader;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import static org.junit.jupiter.api.Assertions.assertEquals;

/**
 * The HiddenTests class for the Lab in CSC207, Fall 2022.
 * These tests are intended for marking.  In our class, we gave 25% of the marks for passing student tests.
 * Another 75% of the marks were awarded for passing the tests in both this file AND TreeViewerTest.java.
 */
public class HiddenTests {

    List<MunicipalTree> trees;

    @BeforeEach
    void getTrees(){
        try {
            String filename = "assets/treelist-utm.csv"; //change this accordingly
            this.trees = TreeReader.readTreesFromFile(filename);
        } catch (IOException ioe) {
            throw new RuntimeException(ioe);
        }
    }

    @Test
    void countTreeHiddenTest() {
        int count = TreeInfo.getTreeCount("BALSAM FIR", this.trees);
        assertEquals(37,count);
    }

    //List<MunicipalTree> trees;
    @Test
    void getTreeTypeHiddenTest() {
        ArrayList<MunicipalTree> trees;
        try {
            String filename = "assets/treelist-utm.csv"; //change this accordingly
            trees = (ArrayList<MunicipalTree>) TreeReader.readTreesFromFile(filename);
        } catch (IOException ioe) {
            throw new RuntimeException(ioe);
        }
        final Set<String> types = TreeInfo.getTreeTypes(trees);
        assertEquals(184,types.size());
    }

    @Test
    void countTreeHidden2Test() {
        int count = TreeInfo.getTreeCount("AUTUMN BLAZE MAPLE", trees);
        assertEquals(184,count);
    }


    @Test
    void countTreeHidden3Test() {
        int count = TreeInfo.getTreeCount("APPLE CRAB", trees);
        assertEquals(14,count);
    }

    @Test
    void countTreeHidden4Test() {
        int count = TreeInfo.getTreeCount("NORWAY MAPLE", trees);
        assertEquals(3092,count);
    }

}
