package decorator;

import trees.MunicipalTree;

/**
 * Abstract Class TreeDecorator
 */
public abstract class TreeDecorator extends MunicipalTree {

    MunicipalTree currentTree; //wrap the current tree

    //must override getters!
    @Override
    public double [] getBarkParams() {
        return currentTree.getBarkParams();
    }
    @Override
    public double [] getWoodParams() {
    }
    
    @Override
    public double [] getFoliageParams() {
        return currentTree.getFoliageParams();
    }

    @Override
    public double getDiameter() {
        return currentTree.getDiameter();
    }

    @Override
    public String getName() {
        return currentTree.getName() + " Tree Decorator";
    }


}
