package decorator;

import trees.MunicipalTree;

/**
 * Class BarkDecorator, incorporates bark in calculation of a tree's carbon content
 */
public class BarkDecorator extends TreeDecorator {

    /**
     * Create a BarkDecorator and initialize its carbon content
     */
    public BarkDecorator(MunicipalTree tree) {
        currentTree = tree;
    }

    @Override
    public double calculateCarbonContent() {
        return currentTree.calculateCarbonContent() + 0.47*(currentTree.getBarkParams()[0]*Math.pow(currentTree.getDiameter(), currentTree.getBarkParams()[1]));
    }

}
