package decorator;

import trees.MunicipalTree;

/**
 * Class FoliageDecorator, incorporates foliage in calculation of a tree's carbon content
 */
public class FoliageDecorator extends TreeDecorator {

    /**
     * Create a FoliageDecorator and initialize its carbon content
     */
    public FoliageDecorator(MunicipalTree tree) {
        currentTree = tree;
    }

    @Override
    public double calculateCarbonContent() {
        return currentTree.calculateCarbonContent() + 0.47*(currentTree.getFoliageParams()[0]*Math.pow(currentTree.getDiameter(), currentTree.getFoliageParams()[1]));
    }

}

