package decorator;

import trees.MunicipalTree;

/**
 * Class FoliageDecorator, incorporates foliage in calculation of a tree's carbon content
 */
public class FoliageDecorator extends TreeDecorator {

    /**
     * Create a FoliageDecorator and initialize its carbon content
     */
    public FoliageDecorator(MunicipalTree tree) {
        currentTree = tree;
    }

    @Override
    public double calculateCarbonContent() {
        return 0.47*(this.getFoliageParams()[1]*Math.pow(this.getDiameter(), this.getFoliageParams()[0]));
    }

}

