import decorator.BranchDecorator;
import decorator.BarkDecorator;
import decorator.TreeDecorator;
import trees.NorwayMaple;

/**
 * Main Class. Create some trees and print them out.  Decorate some of the string descriptions.
 */
public class Main {

    /**
     * Main Method
     *
     * @param args arguments, if any
     */
    public static void main(String[] args) {

        NorwayMaple m = new NorwayMaple(20.2);
        System.out.println(m.getCarbonContent()); // Should print "My carbon content is [calculated value] (accounting for only my wood)"

        TreeDecorator b = new BarkDecorator(m);
        System.out.println(b.getDescription()); // Should print "My carbon content is [calculated value] (accounting foy my wood and bark)"

        TreeDecorator c = new BranchDecorator(b);
        System.out.println(c.getDescription()); // Should print "My carbon content is [calculated value] (accounting foy my wood, bark, and branches)"
    }
}