import decorator.*;
import trees.Beech;
import trees.WhiteAsh;
import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.assertEquals;

/**
 * Class HiddenTests, tests for marking (not to be released to students)
 */
public class HiddenTests {

    @Test
    void TreeDecoratorFirstHiddenTest() {
        WhiteAsh m = new WhiteAsh();
        assertEquals( 13.3, m.calculateCarbonContent(),1); //wood alone

        TreeDecorator b = new BarkDecorator(m);
        assertEquals(14.2,b.calculateCarbonContent(), 1 );  //wood + bark

        TreeDecorator c = new FoliageDecorator(b);
        assertEquals(16.0, c.calculateCarbonContent(), 1); //wood + bark + foliage
    }

    @Test
    void TreeDecoratorSecondHiddenTest() {
        Beech m = new Beech();
        assertEquals(6.1, m.calculateCarbonContent(), 1); //wood alone

        TreeDecorator b = new BarkDecorator(m);
        assertEquals( 7.0, b.calculateCarbonContent(),1);  //wood + bark

        TreeDecorator c = new FoliageDecorator(b);
        assertEquals( 7.3, c.calculateCarbonContent(), 1); //wood + bark + foliage
    }

    @Test
    void MixedHiddenTest() {
        WhiteAsh m = new WhiteAsh();
        assertEquals( 13.3, m.calculateCarbonContent(),1); //wood alone

        TreeDecorator b1 = new BarkDecorator(m);
        assertEquals( 14.2, b1.calculateCarbonContent(),1);  //wood + bark

        TreeDecorator c1 = new FoliageDecorator(b1);
        assertEquals(16.0, c1.calculateCarbonContent(), 1); //wood + bark + foliage

        TreeDecorator b2 = new FoliageDecorator(m);
        assertEquals( 14.1, b2.calculateCarbonContent(),1);  //wood + bark

        TreeDecorator c2 = new BarkDecorator(b2);
        assertEquals( 16.0, c2.calculateCarbonContent(),1); //wood + bark + foliage

        assertEquals(c2.calculateCarbonContent(), c1.calculateCarbonContent(),1); //should both be equal

    }    
}