# Project Title

TOOLS FOR MARKING

## Description

What is in this folder:

```bash
README-shared.md #this README
run_tests.sh #script to run JUnit5 (and TestFX) Tests for a set of submissions in any of the lab folders.  This script is for a Mac (zsh) and contains references to paths that may need to be adjusted for other machines.		
tally_marks.py  #Python 3+ script to tally marks and generate reports for a set of submissions in any of the lab folders. Produces reports in each student folder and results.csv files.
junit-platform-console-standalone-1.9.0.jar #jar required to run JUnit5 tests from the command line
```

### Dependencies

For lab 1,3 and 4:<p>

* zsh (for run_tests.sh)
* JavaFX 18
* JUnit 5
* Python 3.9.6, and the following imports:

```python
import os
import re
import string
import sys
```

For lab 2, which includes GUI tests:<p>

* Apache Maven: version 3.6.3 
* Maven Surefire Plugin: version 2.22.0 
* JavaFX: version 20-ea+4 
* TestFX: version 4.0.16-alpha 

### Marking Criteria

Tally marks will:

* Award 25% for passing student tests (in StudentTests.java)
* Award 75% for passing hidden tests (in HiddenTests.java. Lab 2 includes additional GUI tests in TreeViewerTest.java and TreeViewerTestBase.java)

## Marking a Submission

Note that the shell scrips have been tested only on Mac OS. Make sure you are inside the shared_files folder when running the commands below from the console. <br />

```bash
chmod 775 run_tests.sh #to ensure marking script is runnable (on a Mac!)

./run_tests.sh lab-1 #to run tests on Lab 1
python3 tally_marks.py lab-1 #to tally Lab 1 marks and generate reports

./run_tests.sh lab-2 #to run tests on Lab 2
python3 tally_marks.py lab-2 #to tally Lab 2 marks and generate reports

./run_tests.sh lab-3 #to run tests on Lab 3
python3 tally_marks.py lab-3 #to tally Lab 3 marks and generate reports

./run_tests.sh lab-4 #to run tests on Lab 4
python3 tally_marks.py lab-4 #to tally Lab 4 marks and generate reports

```

## For More Information

TBA


