#requires rsync  version 2.6.9 

echo "\nLab Folder is: $1\n";

for d in ../${1}/example_submissions/* ; do

    echo "WORKING ON: ${d/\.\.\/$1\/example_submissions\//}"

    #any java files in here?
    if [[ -n $(find "$d" -type f -name "*.java") ]] 
    then
        
        #if yes, get into student folder                    
        cd "$d"

        # copy over supporting java files (hidden and student facing tests, plus pom.xml for GUI tests)  
        rsync -avi --include="*/" --include '*.png' --include '*.xml' --include '*.csv' --include '*.java' --exclude '*' ../../supporting_files/ .
        echo "$1"
        # cp ../../supporting_files/*.csv .

        if [[ "$1" = "lab-2" ||  "$1" = "lab-2/" ]] #Lab 2 is the GUI based lab!!
        then

            # is a GUI based assignment, so use mvn to compile and run (to deal with dependencies)
            mvn compile 2> compile_errors.txt #(make sure you are using JAVA 18)   
            mvn test > gui_test_results.txt

            # also run the JUnit Tests (make sure you are using JAVA 18)                  
            $JAVA_HOME/bin/java -jar ../../../shared_files/junit-platform-console-standalone-1.9.0.jar -cp target/classes/ --scan-classpath > junit_test_results.txt        

        else #if there are no GUI tests

            # compile the files (make sure you are using JAVA 18)   
            $JAVA_HOME/bin/javac -Xlint:unchecked -d out/ -sourcepath . -cp ../../../shared_files/junit-platform-console-standalone-1.9.0.jar *.java  2> compile_errors.txt    

            # run the JUnit tests (make sure you are using JAVA 18)           
            $JAVA_HOME/bin/java -jar ../../../shared_files/junit-platform-console-standalone-1.9.0.jar -cp out/ --scan-classpath > junit_test_results.txt        

        fi

        # continue
        cd ../../../shared_files/

    fi

done
